--- old/usr/src/tools/cw/cw.c	2019-07-14 19:12:39.048956981 +0000
+++ new/usr/src/tools/cw/cw.c	2019-07-14 19:12:39.064536838 +0000
@@ -306,6 +306,7 @@
 typedef struct cw_ictx {
 	struct cw_ictx	*i_next;
 	cw_compiler_t	*i_compiler;
+	char		*i_linker;
 	struct aelist	*i_ae;
 	uint32_t	i_flags;
 	int		i_oldargc;
@@ -1209,14 +1210,6 @@
 			/* Just ignore -YS,... for now */
 			if (strncmp(arg, "S,", 2) == 0)
 				break;
-			if (strncmp(arg, "l,", 2) == 0) {
-				char *s = strdup(arg);
-				s[0] = '-';
-				s[1] = 'B';
-				newae(ctx->i_ae, s);
-				free(s);
-				break;
-			}
 			if (strncmp(arg, "I,", 2) == 0) {
 				char *s = strdup(arg);
 				s[0] = '-';
@@ -1468,6 +1461,9 @@
 		(void) fflush(stdout);
 	}
 
+	if (ctx->i_linker != NULL)
+		setenv("LD_ALTEXEC", ctx->i_linker, 1);
+
 	if (!(ctx->i_flags & CW_F_XLATE))
 		return;
 
@@ -1727,6 +1723,7 @@
 
 	static struct option longopts[] = {
 		{ "compiler", no_argument, NULL, 'c' },
+		{ "linker", required_argument, NULL, 'l' },
 		{ "noecho", no_argument, NULL, 'n' },
 		{ "primary", required_argument, NULL, 'p' },
 		{ "shadow", required_argument, NULL, 's' },
@@ -1746,6 +1743,10 @@
 		case 'C':
 			Cflg = B_TRUE;
 			break;
+		case 'l':
+			if ((main_ctx->i_linker = strdup(optarg)) == NULL)
+				nomem();
+			break;
 		case 'n':
 			nflg = B_TRUE;
 			break;
